import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'adgydeflutterplugin_method_channel.dart';

abstract class AdgydeflutterpluginPlatform extends PlatformInterface {
  /// Constructs a AdgydeflutterpluginPlatform.
  AdgydeflutterpluginPlatform() : super(token: _token);

  static final Object _token = Object();

  static AdgydeflutterpluginPlatform _instance =
      MethodChannelAdgydeflutterplugin();

  /// The default instance of [AdgydeflutterpluginPlatform] to use.
  ///
  /// Defaults to [MethodChannelAdgydeflutterplugin].
  static AdgydeflutterpluginPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [AdgydeflutterpluginPlatform] when
  /// they register themselves.
  static set instance(AdgydeflutterpluginPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<String?> getPlatformVersion() {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  void init(String appkey, String channel) {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  void simpleEvent(String eventValue) {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  void countingEvent(String eventId, Map eventValue) {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  void computingEvent(String eventId, Map eventValue) {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  void daliyUnique(String eventId, Map eventValue) {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  void permanentUnique(String eventId, Map eventValue) {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  void customUnique(String eventId, Map eventValue, int time) {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  void setCurrentScreen(String screenName) {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  void removeCurrentScreen(String screenName) {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  void getEmailId(String emailId) {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  void getPhoneNumber(int phoneno) {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  void setClientUserId(String clientUserid) {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  void revenueEvent(int revenue) {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  void fcmToken(String token) {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  void setAge(String age) {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  void setGender(String gender) {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  void setImeiPermission(bool imei) {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  Future<String?>  getDeeplinkData() async {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  Future<String?> getUserId() async {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  Future<String?>  getCampaignName() async {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  Future<String?>  getCampaignId() async {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  Future<String?>  getChannelName() async {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  Future<String?>  getchannelId() async {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  Future<String?>  getMediaSource() async {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  Future<String?>  getUtmSource() async {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }
}
